<?xml version="1.0" encoding="UTF-8"?>
<project xmlns="http://maven.apache.org/POM/4.0.0"
         xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
    <modelVersion>4.0.0</modelVersion>

    <groupId>test.automation.solution</groupId>
    <artifactId>TestAutomationSolution</artifactId>
    <version>1.0</version>
    <description>Test Automation Solution</description>

    <properties>
        <project.build.sourceEncoding>UTF-8</project.build.sourceEncoding>
        <maven.compiler.source>11</maven.compiler.source>
        <maven.compiler.target>11</maven.compiler.target>
        <apache.maven.plugins-version>3.0.0-M9</apache.maven.plugins-version>
        <log4j-version>2.20.0</log4j-version>
        <extentreports-version>5.0.8</extentreports-version>
        <assertj-version>3.24.2</assertj-version>
        <selenide-version>6.13.0</selenide-version>
        <testng-version>7.7.1</testng-version>
        <lombok-version>1.18.26</lombok-version>
        <rest-assured-version>5.3.0</rest-assured-version>
        <wiremock-version>2.35.0</wiremock-version>
        <threadCount>1</threadCount>
        <testSuiteName>all_tests</testSuiteName>
    </properties>

    <dependencies>
        <!-- Maven Surefire Plugin  https://mvnrepository.com/artifact/org.apache.maven.plugins/maven-surefire-plugin -->
        <dependency>
            <groupId>org.apache.maven.plugins</groupId>
            <artifactId>maven-surefire-plugin</artifactId>
            <version>${apache.maven.plugins-version}</version>
        </dependency>
        <!-- TestNG https://mvnrepository.com/artifact/org.testng/testng -->
        <dependency>
            <groupId>org.testng</groupId>
            <artifactId>testng</artifactId>
            <version>${testng-version}</version>
        </dependency>
        <!-- Selenide-TestNG https://mvnrepository.com/artifact/com.codeborne/selenide-testng -->
        <dependency>
            <groupId>com.codeborne</groupId>
            <artifactId>selenide-testng</artifactId>
            <version>${selenide-version}</version>
        </dependency>
        <!-- AssertJ https://mvnrepository.com/artifact/org.assertj/assertj-core -->
        <dependency>
            <groupId>org.assertj</groupId>
            <artifactId>assertj-core</artifactId>
            <version>${assertj-version}</version>
            <scope>test</scope>
        </dependency>
        <!-- ExtentReports https://mvnrepository.com/artifact/com.aventstack/extentreports -->
        <dependency>
            <groupId>com.aventstack</groupId>
            <artifactId>extentreports</artifactId>
            <version>${extentreports-version}</version>
        </dependency>
        <!-- Log4j Core https://mvnrepository.com/artifact/org.apache.logging.log4j/log4j-core -->
        <dependency>
            <groupId>org.apache.logging.log4j</groupId>
            <artifactId>log4j-core</artifactId>
            <version>${log4j-version}</version>
        </dependency>
        <!-- SLF4J Bridge (to fix Failed to load class org.slf4j.impl.StaticLoggerBinder) https://mvnrepository.com/artifact/org.apache.logging.log4j/log4j-slf4j-impl -->
        <dependency>
            <groupId>org.apache.logging.log4j</groupId>
            <artifactId>log4j-slf4j-impl</artifactId>
            <version>${log4j-version}</version>
            <scope>test</scope>
        </dependency>
        <!-- Project Lombok https://mvnrepository.com/artifact/org.projectlombok/lombok -->
        <dependency>
            <groupId>org.projectlombok</groupId>
            <artifactId>lombok</artifactId>
            <version>${lombok-version}</version>
            <scope>provided</scope>
        </dependency>
        <!-- REST Assured https://mvnrepository.com/artifact/io.rest-assured/rest-assured -->
        <dependency>
            <groupId>io.rest-assured</groupId>
            <artifactId>rest-assured</artifactId>
            <version>${rest-assured-version}</version>
        </dependency>
        <!-- WireMock https://mvnrepository.com/artifact/com.github.tomakehurst/wiremock -->
        <dependency>
            <groupId>com.github.tomakehurst</groupId>
            <artifactId>wiremock-jre8-standalone</artifactId>
            <version>${wiremock-version}</version>
            <scope>compile</scope>
        </dependency>
    </dependencies>
    <build>
        <pluginManagement>
            <plugins>
                <plugin>
                    <groupId>org.apache.maven.plugins</groupId>
                    <artifactId>maven-surefire-plugin</artifactId>
                    <version>${apache.maven.plugins-version}</version>
                    <configuration>
                        <parallel>tests</parallel>
                        <!--passing ass command-line attribute, default: 1-->
                        <threadCount>${threadCount}</threadCount>
                        <suiteXmlFiles>
                            <!--passing ass command-line attribute, default: all_tests-->
                            <suiteXmlFile>
                                src/main/resources/suites/${testSuiteName}.xml
                            </suiteXmlFile>
                        </suiteXmlFiles>
                        <properties>
                            <property>
                                <name>usedefaultlisteners</name>
                                <value>false</value> <!-- disabling default listeners -->
                            </property>
                            <property>
                                <name>ExtentReportTestListener</name>
                                <value>com.taf.utils.listeners.ExtentReportTestListener</value>
                            </property>
                        </properties>
                    </configuration>
                </plugin>
            </plugins>
        </pluginManagement>
    </build>
</project>